*=============== RESTRT ==========================================
*
      SUBROUTINE RESTRT(NNN)
*
      include "prcm.h"
      character*12 LAB
*  reserved place in the .dmp file   
	real*8 SHUTA(10)
	save NSTTOT0,NSTEPA0
	data NSTTOT0/0/,NSTEPA0/0/
*
      GO TO (1000,2000),NNN
*
      STOP ' NO VALID OPTION IN RESTRT !!!'
 1000 CONTINUE
	I40=1
      open (unit=7,file=fdump,status="old",form='unformatted',err=1001)
    5 read(7)LAB
      if(LAB.ne.LABEL)then
        if(I40.ne.0.and.TASKID.eq.MAST)
     +  write(*,*)"!!! Wrong dump file: label=",LAB
*        stop ' '
      end if 
      MOP=NOP
      MS=NSITES
      read(7) NOP,NSITES,NSTOT,NNAV,DTT
      READ (7) MSTEP,NSTTOT,NSTEPA,NAVT,NHIST,TIM,TIMA,NTRKF,NTRKZ
      IF(MOP.NE.NOP)    STOP'...NOP    CERTAINLY WRONG RESTART FILE !!!'
      IF(MS .NE.NSITES )STOP'...NSITES CERTAINLY WRONG RESTART FILE !!!'
*  compatibility with v.<4.0
	if(I40.ne.0)then 
        READ (7,err=8) SC,SCL,BOXL,VOL,CUTRDF,BOYL,BOZL,SCLX,SCLY,SCLZ 
	else
        READ (7,err=14) SC,SCL,BOXL,VOL,CUTRDF,BOYL,BOZL 
	  LSEP=.false.
	  go to 13
 14 	  BOYL=BOXL
 	  BOZL=BOXL
	end if
	go to 13
  8   I40=0 
	rewind (7)
	go to 5
  13  read(7,err=12) timest,timea,timeb,timee,timef,timeg,timel,
     +timen,timet,timev,times
  12  read(7) (SX(I),SY(I),SZ(I),I=1,NSTOT)
      read(7) (VX(I),VY(I),VZ(I),I=1,NSTOT)
      READ (7) (AV(I),AW(I),I=1,NNAV)
      do J=1,NHIST
        read(7,err=11)(HIST(I,J),I=1,NNAV)
      end do
 11   close (7)    
	if(.not.LSEP)then                             
   	  SCLX=SCL/3.
   	  SCLY=SCL/3.
	  SCLZ=SCL/3.    
	end if
	if(LGRST.and.CUTRDF.gt.0.d0)RDFCUT=CUTRDF
	NSTTOT0=NSTTOT
	NSTEPA0=NSTEPA
	if(TASKID.eq.MAST)then
      PRINT *
      PRINT "('*** restart file read in from ',a)",fdump
      PRINT *
      PRINT "('*** NR OF PARTICLES            ',I6)",MOP
      PRINT "('*** NR OF SITES                ',I6)",MS
      PRINT "('*** NR OF PREVIOUS STEPS       ',I8)",NSTTOT
      print "('*** NR of steps with time ac.  ',I8)",NSTEPA
      PRINT "('*** TIME STEP USED(in fs)              ',f10.4)",
     +DTT*1.d15          
	end if
	IF(DTT.NE.DT)then
        if(TASKID.eq.MAST)PRINT 
     +  "('... NOT THE SAME AS IN PRESENT RUN --> ',f10.4)",DT*1.d15
        if(TASKID.eq.MAST)PRINT *, "Velocities are scaled"
	  do I=1,NSTOT
	    VX(I)=VX(I)*DT/DTT
	    VY(I)=VY(I)*DT/DTT
	    VZ(I)=VZ(I)*DT/DTT
	  end do  
	  SCL=SCL*DT/DTT     
	  SCY=SCY*DT/DTT     
	  SCZ=SCZ*DT/DTT     
	  SC=SC*DT/DTT     
	  call GETEMP(.true.)
	  write(*,*)'Temperature is ',TEMP
	end if
	if(TASKID.eq.MAST)
     +PRINT "('*** short time step (in fs)            ',f10.4)",
     +DT*1.d15/NFREQ
*
	if(L0AVS)then
	  TIMEST=0.
	  TIMEA=0.
	  TIMEB=0.
	  TIMEE=0.
	  TIMEF=0.
	  TIMEG=0.
	  TIMEL=0.
	  TIMEN=0.
	  TIMET=0.
	  TIMEV=0.
	  TIMES=0.
	  NSTEPA0=0
	end if
      IF(L0VS) THEN    
      DO N  = 1,NSTOT
      VX(N) = 0.D0
      VY(N) = 0.D0
      VZ(N) = 0.D0
      END DO! OF N 
*
      if(TASKID.eq.MAST)
     +PRINT "(/,'*** OLD VELOCITIES AND FORCES ZEROED ! ***',/)"
*
      END IF
*
      DO N  = 1,NSTOT
      OX(N) = SX(N)
      OY(N) = SY(N)
      OZ(N) = SZ(N)
      END DO! OF N
*
      RETURN
 2000 CONTINUE
	if(TASKID.eq.MAST)then
      NSTTOT1=NSTTOT0+NSTEP
      NSTEPA1=NSTEPA0+NSTEP
      TIM0	= TIM+NSTEP*DT
      TIMA0	= TIMA+NSTEP*DT
      time	= timest+cputime(time0)
	if(.not.LSEP)then                             
   	  SCLX=SCL/3.
   	  SCLY=SCL/3.
	  SCLZ=SCL/3.    
	end if
      open (unit=8,file=fdump,status="unknown",form='unformatted')
      write(8)LABEL
      write(8) NOP,NSITES,NSTOT,NNAV,DT
      write(8) NSTEP,NSTTOT1,NSTEPA1,NAVT,NHIST,TIM0,TIMA0
     +,NTRKF,NTRKZ
      WRITE(8) SC,SCL,BOXL,VOL,RDFCUT,BOYL,BOZL,SCLX,SCLY,SCLZ,SHUTA
      write(8) time,timea,timeb,timee,timef,timeg,timel,timen,timet,
     +timev,times      
	WRITE(8) (SX(I),SY(I),SZ(I),I=1,NSTOT)
      WRITE(8) (VX(I),VY(I),VZ(I),I=1,NSTOT)
      write(8) (AV(I),AW(I),I=1,NNAV)
      do J=1,NHIST
        write(8)(HIST(I,J),I=1,NNAV)
      end do
      close(8)
      PRINT *
      write(6,'(2a)')'*** restart file dumped on ',fdump
      PRINT *            
	end if
      if(LGR.and.LGDMP.and.NHIST.ge.IHIST)call RDFOUT(0)
	if(TASKID.ne.MAST)return 
	if(LCF.and.LCFDMP.and.NHIST.ge.IHIST)call TCFOUT(0)
*
      RETURN       
 1001 write(*,*)' File ',fdump,' not found on node ',TASKID
	stop
      END 
*
*======================= TRACE ========================================
*
      subroutine TRACE
c Dump to file all interesting values
      include "prcm.h"
c
      save
	logical lfirst 
c
      real*8 fdir(3)
	data lfirst /.true./,fdir/3*0.d0/
	if(ITREK.le.0.or.TASKID.ne.MAST)return
	NTRKZ=NTRKZ+1
	if(NTRKZ.gt.LTREK)then
	  if(.not.lfirst)then
	    close(55)
	    write(*,*)' close file ',FTRK
	  end if
	  lfirst=.true.
	end if
c
      if( lfirst ) then ! initialization of trk file
        lfirst = .false.
c
c - delete old file (useful on Convex)
        NTRKZ=1
	  NTRKF=NTRKF+1
        write(ftrk(ICFN:ICFN+2),'(i3)')NTRKF
	  if(ftrk(ICFN:ICFN).eq.' ')FTRK(ICFN:ICFN)='0'
	  if(ftrk(ICFN+1:ICFN+1).eq.' ')FTRK(ICFN+1:ICFN+1)='0'
	  open( 55, file=ftrk, iostat=i ) ! open file as text-file
        if( i.ne.0 ) then
          write( *,* )'---Can not open coordinate file'
          return
        endif
        rewind 55      !\ - goto beginning
        write( 55, * ) !| - write 1 byte <LF>
        close( 55 )    !/ - close == leave file contained 1 byte
c                              
	  if(ITREK.ne.2)then
c - start to write binary file:
          open(unit=55, form='unformatted',file=ftrk)
	  else
	    open(unit=55, file=ftrk)
	  end if
c
c - 0 (null) = nomer shaga (not in use)       I4
c - deltat - shag integrirovaniya [s]         R8
c - box* - [Angstr]                         3*R8
c - unitl - [m]                               R8
c - ntypes - kol-vo tipov                     I4
c - nspecs, nsites - ponyatno               2*I4
c - .true. - ostatok ot LMOVE(I) (not in use) L4
c
	  if(ITREK.ne.2)then
          write( 55 ) 0, dt, boxl, boyl, bozl, unitl, ntypes,
     x                (nspec(i),nsits(i),.true.,i=1,ntypes)
c
c - dmass2(INDEX(ityp,iatom)) - atomic mass in [AMU]  R8
c - dlya kazhdogo tipa - otdel'naya FORTRAN'naya zapis
          do ityp=1, ntypes
            NSB            =  ISADR (ITYP)+1
            NSE            =  ISADR (ITYP+1)
            write( 55 ) (mass(j), j=NSB,NSE),LIST(ITYP)
          end do
	  end if
	  if(ITREK.ne.0)write(*,*)' start of dumping trace in file ',ftrk
      endif ! first call
c
c ---- novyj shag:
c
c - 0 (null) - nomer shaga
c - fultim - polnoe vremya s nachala MD-modelirovaniya [s]  R8
c - cumtim - vremya s nachala analiza MD-modelirovaniya [s] R8
c - fdir(3) - massiv orientacii direktora zh.k.           3*R8
	fultim=TIM+NSTEP*DT
	cumtim=HIST(1,IHIST)*1.d-12
c - for the XMol program
	if(ITREK.eq.2)then
	  NSDP=0 
	  do ITYP=1,NTYPES
	    if(LIST(ITYP).ne.0)NSDP=NSDP+NSPEC(ITYP)*NSITS(ITYP)
	  end do
	  write(55,*)NSDP
	  if(IPRINT.ge.5)
     +    write(*,*)'add ',NTRKZ,' config. after ',fultim*1.d15,' fs'
	  write(55,*)' after ',fultim*1.d15,' fs'
	  do I=1,NSTOT
	    ISB=NSITE(I)
	    ITYP=ITYPE(I)
	    if(LIST(ITYP).ne.0)write(55,'(a2,3(1x,f8.3))')
     +      NM(ISB)(1:2),real(SX(I)),real(SY(I)),real(SZ(I))
	  end do
	else                    
	  FDIR(1)=TEMP
        write( 55 ) 0, fultim, cumtim, fdir,BOXL,BOYL,BOZL,LIST
	  if(IPRINT.ge.5)
     +    write(*,*)'add ',NTRKZ,' config. after ',fultim*1.d15,' fs'
c
c - dlya kazhdogo tipa!
        do ityp=1,ntypes
           NSB          = ISADDR(ITYP)+1
           NSE         = ISADDR(ITYP+1)
           if(LIST(ITYP).ne.0)write( 55 ) (real(SX(j)),j=NSB,NSE),
     *                (real(SY(j)),j=NSB,NSE),
     *                (real(SZ(j)),j=NSB,NSE)
        end do
	end if
      end 
*
*==================== BIODUMP =======================================
* 
	subroutine BIODUMP
* System configuration for BIOSYM program
	include "prcm.h" 
	ANG=90.
	if(TASKID.ne.MAST)return
	open(unit=19,file=fmol,status='unknown')
	write(19,'(a)')'!BIOSYM archive 2'
      write(19,'(a)')'PBC=ON'
      write(19,'(a)')' system configuration'
      write(19,'(a)')'!DATE'
      write(19,'(a3,6f10.4,a5)')
     +'PBC',BOXL,BOYL,BOZL,ANG,ANG,ANG,' (P1)'
	N=0
	I=0
	do ITYP=1,NTYPES
        NSBEG       = ISADR  (ITYP)+1
        NSEND       = ISADR  (ITYP +1)
        DO J        = 1,NSPEC(ITYP)
	    I=I+1
          DO IS       = NSBEG,NSEND
            N           = N+1
            write(19,'(a4,1x,3f15.7,1x,a4,i4,2x,a2,1x,a2,1x,f8.4,i4)')
     + NM(IS),SX(N),SY(N),SZ(N),NAME(ITYP)(1:4),ITYP,'h ',NM(IS)(1:2),
     + CHARGE(IS),N
	    end do
	    write(19,'(a3)')'end'
	  end do
	end do
      write(19,'(a3)')'end'
	write(*,*)' Configuration file dumped to ',fmol
	return
	end               
*
*===================== XMOLDUMP ======================================
*
	subroutine XMOLDUMP
	include "prcm.h"     
	if(TASKID.ne.MAST)return
	open(unit=21,file=fmol,status='unknown') 
      NSDP=0
	do ITYP=1,NTYPES
	    if(LIST(ITYP).ne.0)NSDP=NSDP+NSPEC(ITYP)*NSITS(ITYP)
	end do
	write(21,*)NSDP 
	fultim=TIM+NSTEP*DT
	write(21,*)' after ',fultim*1.d12,' ps'
	do I=1,NSTOT 
        ITYP=ITYPE(I)
	  IS=NSITE(I)
	  if(LIST(ITYP).ne.0)write(21,*)NM(IS)(1:2),SX(I),SY(I),SZ(I)
	end do  
	close(21)
	return
	end
